#include "DualTB9051FTGMotorShield.h"

DualTB9051FTGMotorShield md;
const byte LM_INT0_PIN = 19;
const byte LM_INT1_PIN = 18;
const byte RM_INT0_PIN = 21;
const byte RM_INT1_PIN = 20;

int left_irq_flag;
int right_irq_flag;
int rising_cnt_0=0;
int falling_cnt_0=0;
int rising_cnt_1=0;
int falling_cnt_1=0;
int done=0;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Serial.println("SETUP");
  md.init();

  pinMode(LM_INT0_PIN, INPUT_PULLUP);
  pinMode(LM_INT1_PIN, INPUT_PULLUP);
  pinMode(RM_INT0_PIN, INPUT_PULLUP);
  pinMode(RM_INT1_PIN, INPUT_PULLUP);

  attachInterrupt(digitalPinToInterrupt(LM_INT0_PIN), update_lm_theta0_r, RISING);
  attachInterrupt(digitalPinToInterrupt(LM_INT0_PIN), update_lm_theta0_f, FALLING);
  attachInterrupt(digitalPinToInterrupt(LM_INT1_PIN), update_lm_theta1_r, RISING);
  attachInterrupt(digitalPinToInterrupt(LM_INT1_PIN), update_lm_theta1_f, FALLING);
}

void loop() {
  // put your main code here, to run repeatedly:

    if(!done)
    {
        md.enableDrivers();
        md.setM2Speed(0);
        while (Serial.available() == 0) {}
    
        md.setM2Speed(100);
        delay(1000);
            
        Serial.print("rising_cnt_0: ");
        Serial.print(rising_cnt_0);
        Serial.print("\n");
    
        Serial.print("falling_cnt_0: ");
        Serial.print(falling_cnt_0);
        Serial.print("\n");
    
        Serial.print("rising_cnt_1: ");
        Serial.print(rising_cnt_1);
        Serial.print("\n");    
    
        Serial.print("falling_cnt_1: ");
        Serial.print(falling_cnt_1);
        Serial.print("\n");

        done = 1;
    }
    md.setM2Speed(0);

}

void update_lm_theta0_r()
{
    rising_cnt_0++;
}

void update_lm_theta0_f()
{
    falling_cnt_0++;
}

void update_lm_theta1_r()
{
    rising_cnt_1++;
}

void update_lm_theta1_f()
{
    falling_cnt_1++;
}
